######### Crossover operator preserving successive values in a permutation
function OX_crossover(parent1, parent2)                      # Parent solutions
    n = length(parent1)
    # Randomly generate the portion of parent1 that is copied in child
    point2, point1 = unif(1, n - 2), unif(1, n - 3)
    if point1 >= point2
        temp = point2
        point2 = point1 + 1
        point1 = temp
    end
    # Copy the portion of parent1 at the beginning of child 
    child = fill(-1, n)
    inserted = fill(false, n)              # Elements already inserted in child
    for i in 1:(point2 - point1+1)
        child[i] = parent1[i + point1]
        inserted[child[i]] = true
    end

    # Last element of parent2 inserted in child
    i = findfirst(==(child[point2 - point1 + 1]), parent2)
    nr_inserted = point2 - point1 + 1

    # Insert remaining elements in child, in order of appearance in parent2
    while nr_inserted < n
        i += 1
        if !inserted[parent2[mod1(i, n)]]
            nr_inserted += 1
            child[nr_inserted] = parent2[mod1(i, n)]
            inserted[parent2[mod1(i, n)]] = true
        end
    end
    return child
end
