######### Data structure building for performing 2-opt move in constant time
function build_2opt_data_structure(tour) # Sequence of visit of the cities
    n = length(tour)
    t = Vector{Int}(undef, 2n + 1) # Index 1 lost 
    for i in 1:n # Forward tour
        t[2tour[i]] = 2tour[mod1(i + 1, n)]
    end
    for i in 2:n # Backward tour
        t[2tour[i] + 1] = 2tour[i - 1] +1
    end
    t[2tour[1] + 1] = 2tour[n] + 1
    return t
end

