# Dijkstra algorithm for finding all shortest paths from start
function dijkstra(n,                                          # Number of nodes
                  d,                # Distance matrix (with no negative values)
                  start)                                        # Starting node

    order = collect(1:n)          # Nodes sequenced by increasing shortest path
    pred = fill(start, n) # Immediate predecessor on a shortest path from start
    lengths = fill(typemax(d[1,1]), n)                  # Shortest path lengths
    lengths[start] = 0  # Only shortest path to order[1] == start already known
    order[1], order[start] = order[start], order[1]

    for i in 1:(n-1)          # Update shortest path for neighbours of order[i]
        for j in (i+1):n                         # For all neighbours to update
            if lengths[order[i]] + d[order[i], order[j]] < lengths[order[j]]
                lengths[order[j]] = lengths[order[i]] + d[order[i], order[j]]
                pred[order[j]] = order[i]
            end
            # Update order if a better i+1th shortest path is identified
            if lengths[order[i+1]] > lengths[order[j]]
                order[i+1], order[j] = order[j], order[i+1]
            end
        end
    end

    return lengths, pred
end
