include("tsp_utilities.jl")                                         # Code %*\ref{lst:tsp_utilities}*)

######### Building a solution using artificial pheromone trails
function generate_solution_trail(d,                           # Distance matrix
                                 tour,               # Tour produced by the ant
                                 trail)                      # Pheromone trails
    n = length(tour)
    for i in 2:(n - 1)
        total = sum(trail[tour[i - 1],tour[j]] for j in (i + 1):n)
        target = unif(0, total - 1)
        j = i
        total = trail[tour[i - 1],tour[j]]
        while total < target
            total += trail[tour[i - 1],tour[j + 1]]
            j += 1
        end
        tour[j], tour[i] = tour[i], tour[j]
    end
    return tour, tsp_length(d, tour)
end
