######### Inserting a child in a population of solutions
function insert_child(child,               # Individual to insert in population
                      child_fitness,  # Cost of child (the smaller, the better)
                      population_size, 
                      population, 
                      fitness,                     # Fitness of each individual
                      order)         # order[i] : individual number with rank i
    rank = fill(-1, population_size)                      # Rank of individuals
    for i in 1:population_size
        rank[order[i]] = i
    end
    child_rank = 1                                 # Find the rank of the child
    for i in 1:population_size
        if fitness[i] < child_fitness
            child_rank += 1
        end
    end
    if child_rank < population_size                # The child is not dead-born
        if fitness[order[child_rank]] != child_fitness && 
          (child_rank == 1 || fitness[order[child_rank]] != child_fitness)
            population[order[population_size]] = copy(child)
            fitness[order[population_size]] = child_fitness
            for i in 1:population_size
                if rank[i] >= child_rank
                    rank[i] += 1
                end
            end
            rank[order[population_size]] = child_rank
            for i in 1:population_size
                order[rank[i]] = i
            end
        else
            child_rank = population_size
        end
    end
    return child_rank, population, fitness, order
end
