# Lecuyer's random generator; initial seeds
global x10::Int32, x11::Int32, x12::Int32, x20::Int32, x21::Int32, x22::Int32
x10, x11, x12, x20, x21, x22 = 12345, 67890, 13579, 24680, 98765, 43210
function rando()                                        
    global x10, x11, x12, x20, x21, x22
    m, m2 = 2147483647, 2145483479
    a12, q12, r12, a13, q13, r13 = 63308, 33921, 12979, -183326, 11714, 2883
    a21, q21, r21, a23, q23, r23 = 86098, 24919,  7417, -539608,  3976, 2071
    invm = 4.656612873077393e-10

    h = x10 ÷ q13
    p13 = -a13 * (x10 - h * q13) - h * r13
    h = x11 ÷ q12
    p12 = a12 * (x11 - h * q12) - h * r12
    if p13 < 0 p13 += m end
    if p12 < 0 p12 += m end
    x10, x11, x12 = x11, x12, p12 - p13
    if x12 < 0 x12 += m end

    h = x20 ÷ q23
    p23 = -a23 * (x20 - h * q23) - h * r23
    h = x22 ÷ q21
    p21 = a21 * (x22 - h * q21) - h * r21
    if p23 < 0 p23 += m2 end
    if p21 < 0 p21 += m2 end
    x20, x21, x22 = x21, x22, p21 - p23
    if x22 < 0 x22 += m2 end

    h = x12 < x22 ? x12 - x22 + m : x12 - x22
    h == 0 ? 0.5 : h * invm
end

# Returns a random integer between low and high (included)
function unif(low, high)
    return Int(low + trunc((high - low + 1) * rando()))
end

# Generate a random array of n Int with all elements of [1, n]
# Platform-independent equivalent of randperm(n)
function rand_permutation(n)
    p = collect(1:n)
    for i in 1:n-1
        v = unif(i, n)
        p[i], p[v] = p[v], p[i]
    end
    return p
end

# Generate a nxn symmetric matrix with random values, 0 diagonal
function rand_sym_matrix(n, low, high)
    matrix = [0 for i in 1:n, j in 1:n]
    for i in 1:n-1
        for j in i+1:n
            matrix[i, j] = matrix[j, i] = unif(low, high)
        end
    end
    return matrix
end
