"""
Program to test the Fast Ant procedure
Example of execution

Number of cities:
200
Number of FANT iterations:
200
FANT parameter:
30
FANT 1  314
FANT 2  310
FANT 75  308
FANT 175  306
Cost of solution found with FANT 306
"""

include("random_generators.jl")                                     # Code %*\ref{lst:random_generators}*)
include("tsp_FANT.jl")                                              # Code %* \ref{lst:tsp_FANT}*)

println("Number of cities: ")
n = parse(Int, readline())
distances = rand_sym_matrix(n, 1, 99)

println("Number of FANT iterations: ")
fant_iterations = parse(Int, readline())
println("FANT parameter (best solution reinforcement): ")
fant_parameter = parse(Int, readline())

tour, cost = tsp_FANT(distances, fant_parameter, fant_iterations)
println("Cost of solution found with FANT: ", cost)
