# Local search based on 2-opt moves, best move policy
function tsp_2opt_best(d, tour, tour_length)
    n = length(tour)
    best_delta = -1
    while best_delta < 0
        best_delta, best_i, best_j = typemax(Int), -1, -1
        for i = 1:n-2 
            for j = i+2:n 
                if i == 1 || j == n
                    continue
                end
                delta = d[tour[i], tour[j]] + d[tour[i+1], tour[mod1(j+1,n)]] -
                        d[tour[i], tour[i+1]] - d[tour[j], tour[mod1(j+1,n)]]
                if delta < best_delta
                    best_delta, best_i, best_j = delta, i, j
                end
            end
        end
        if best_delta < 0
            tour_length += best_delta
            i, j = best_i+1, best_j      # Reverse path from best_i+1 to best_j
            while i < j
               tour[i], tour[j] = tour[j], tour[i]
               i, j = i + 1, j - 1
            end
        end
    end
    return tour, tour_length
end
