include("tsp_utilities.jl")                                         # Code %*\ref{lst:tsp_utilities}*)
include("build_2opt_data_structure.jl")                             # Code %*\ref{lst:build_2opt_data_structure}*)            

# Local search based on 2-opt moves, first move policy
function tsp_2opt_first(d, tour, tour_length)
    n = length(tour)
    t = build_2opt_data_structure(tour)
    i, last_i = 2, 2
    while t[t[i]] != last_i
        j = t[t[i]]
        while j != last_i && (t[j] != last_i || i != last_i)
            delta = d[i ÷ 2, j ÷ 2] + d[t[i] ÷ 2, t[j] ÷ 2] - 
                    d[i ÷ 2, t[i] ÷ 2] - d[j ÷ 2, t[j] ÷ 2]
            if delta < 0
                next_i, next_j = t[i], t[j]
                t[i],  t[j] = j ⊻ 1, i ⊻ 1
                t[next_i ⊻ 1], t[next_j ⊻ 1] = next_j, next_i
                tour_length += delta
                last_i = i
                j = t[i]
            end
            j = t[j]
        end
        i = t[i]
    end
    return tsp_2opt_data_structure_to_tour(t), tour_length
end

