######### Local search with 3-opt neighborhood and first improvement policy
function tsp_3opt_first(d, succ, tour_length)
    last_i, last_j, last_k = 1, succ[1], succ[succ[1]]
    i, j, k = last_i, last_j, last_k

    while true
        delta = d[i, succ[j]] + d[j, succ[k]] + d[k, succ[i]] -
                d[i, succ[i]] - d[j, succ[j]] - d[k, succ[k]]  # Move cost
        if delta < 0
            tour_length += delta  # Update solution cost
            succ[i], succ[j], succ[k] = succ[j], succ[k], succ[i]# Perform move
            j, k = k, j  # Replace j between i and k
            last_i, last_j, last_k = i, j, k
        end

        k = succ[k]  # Next k
        if k == i  # k at its last value, next j
            j = succ[j]
            k = succ[j]
        end
        if k == i  # j at its last value, next i
            i = succ[i]
            j = succ[i]
            k = succ[j]
        end
        if i == last_i && j == last_j && k == last_k
            break
        end
    end

    return succ, tour_length
end

