######### Variable Neighborhood Search for the TSP
function tsp_VNS(d,                      # Distance matrix, must be symmetrical
                 best_tour,                    # Sequence of cities of TSP tour
                 best_length)                              # Length of the tour
    n = length(best_tour)
    iteration, k = 0, 1      # Number of LK calls, current neighbourhood number
    
    while k < n
        tour = copy(best_tour)
        for _ in 1:k                                      # Perturbate solution
            u = unif(1, n)
            v = unif(1, n)
            tour[u], tour[v] = tour[v], tour[u]
        end
        tour_length = tsp_length(d, tour)
        tour, tour_length = tsp_LK(d, tour, tour_length)
        iteration += 1
        if tour_length < best_length                 # Store improved best tour
            best_tour = copy(tour)
            best_length = tour_length
            println("VNS iteration: $iteration, k: $k, length: $tour_length")
            k = 1
        else
            k += 1                                       # Neighbourhood change
        end
    end
    return best_tour, best_length
end
