# Basic Branch & Bound for the TSP
function tsp_branch_and_bound(d,                              # Distance matrix
                              depth,         # current_tour[1] to [depth] fixed
                              current_tour,          # Solution partially fixed
                              best_tour,                  # Best solution found
                              upper_bound)                # Optimum tour length

    n = length(current_tour)

    for i in depth:n
        tour = copy(current_tour)
        tour[depth], tour[i] = tour[i], tour[depth] # City enumeration at depth
        lb, tour, valid = tsp_lower_bound(d, depth, tour)
        if upper_bound > lb
            if valid
                upper_bound = lb
                best_tour = copy(tour)
                println("Improved: ", upper_bound, best_tour)
            else
                best_tour, upper_bound = 
                 tsp_branch_and_bound(d, depth+1, tour, best_tour, upper_bound)
            end
        end
    end

    return best_tour, upper_bound
end
