# Computation of a naive lower bound for the TSP
function tsp_lower_bound(d,                                   # Distance matrix
                         depth,                  # tour[1] to tour[depth] fixed
                         tour)                                       # TSP tour

    n = length(tour)
    lb = 0            # Length of the path for the cities already fixed in tour
    for j in 1:depth-1
        lb += d[tour[j], tour[j+1]]
    end

    valid = true     # Set to true if every closest successor of j build a tour
    for j in depth:n-1                   # j connected to its closest free city
        minimum = d[tour[j], tour[j+1]]
        for k in n:-1:depth+1
            if k != j && minimum > d[tour[j], tour[k]]
                minimum = d[tour[j], tour[k]]
                if k > j
                    tour[k], tour[j+1] = tour[j+1], tour[k]
                else
                    valid = false
                end
            end
        end
        lb += minimum
    end

    minimum = d[tour[n], tour[1]]  # Come back to first city of the tour
    for j in depth+1:n
        if minimum > d[tour[j], tour[1]]
            valid = false
            minimum = d[tour[j], tour[1]]
        end
    end
    lb += minimum

    return lb, tour, valid  # Lower bound, tour modified, lb == tour length
end
