# Nearest Neighbour greedy heuristic for the TSP
function tsp_nearest_neighbour(d,                             # Distance matrix
                               tour)           # List of cities to be sequenced
    n = length(tour)
    tour_length = 0                                               # Tour length
    for i in 2:n                   # Cities from tour[1] to tour[i-1] are fixed
        nearest = i                               # Next nearest city to insert
        cost_ins = d[tour[i-1], tour[i]]                  # City insertion cost
        for j in (i+1):n                             # Find next city to insert
            if d[tour[i-1], tour[j]] < cost_ins
                cost_ins = d[tour[i-1], tour[j]]
                nearest = j
            end
        end
        tour_length += cost_ins
        tour[i], tour[nearest] = tour[nearest], tour[i]  # Definitive insertion
    end
    tour_length += d[tour[n], tour[1]]                     # Come back to start
    return tour, tour_length
end

