# Constructive algorithm with Nearest Neighbour as Pilot method
function tsp_pilot_nearest_neighbour(d)                 # n x n Distance matrix
    n = size(d, 1)
    tour = collect(1:n)                            # All cities must be in tour

    for q in 1:(n-1)                   # Cities up to q at their final position
        length_r = tsp_length(d, tour)
        to_insert = q
        for r in q:n                 # Choose next city to insert at position q
            sol = copy(tour)                              
            sol[q], sol[r] = sol[r], sol[q]  # Tentative sol: tour[q] at pos. r
            sol[q:n], _ = tsp_nearest_neighbour(d, sol[q:n])
            tentative_length = tsp_length(d, sol)
            if length_r > tentative_length
                length_r = tentative_length
                to_insert = r
            end
        end
        # Put definitively to_insert at position q
        tour[q], tour[to_insert] = tour[to_insert], tour[q]
    end

    return tour, tsp_length(d, tour)
end

