# Record to record iterative local search for the TSP
function tsp_record_to_record(d,         # Distance matrix, must be symmetrical
                              best_tour,                             # TSP tour
                              best_length,
                              iterations)                # Number of iterations
    n = length(best_tour)
    for iteration in 1:iterations
        tour = copy(best_tour)       # No tolerance: always revert to best tour
        
        for _ in 1:2                                      # Perturbate solution
            u = unif(1, n)
            v = unif(1, n)
            tour[u], tour[v] = tour[v], tour[u]
        end        
        tour_length = tsp_length(d, tour)
        
        tour, tour_length = tsp_LK(d, tour, tour_length)
        
        if tour_length < best_length                 # Store improved best tour
            best_tour = copy(tour)
            best_length = tour_length
            println("Record to record $iteration, $tour_length")
        end
    end
    return best_tour, best_length
end

