######## (Re-)initialize all trails
function init_trail(initial_value,               # Initial value for all trails
                    trail)                                   # Pheromone trails
    n = size(trail, 1)
    trail = fill(initial_value, n, n)
    for i in 1:n
        trail[i, i] = 0
    end
    return trail
end

######### Updating trail values
function update_trail(tour,                 # Last solution generated by an ant
                      global_best,                       # Global best solution
                      exploration,             # Reinforcement of last solution
                      exploitation,     # Reinforcement of global best solution
                      trail)                                 # Pheromone trails

    if tour == global_best
        exploration += 1                      # Give more weight to exploration
        trail = init_trail(exploration, trail)
    else
        n = length(tour)
        for i in tour
            trail[tour[i],tour[mod1(i + 1, n)]] += exploration
            trail[global_best[i],global_best[mod1(i + 1, n)]] += exploitation
        end
    end
    return trail, exploration
end
